Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyPhysicsListMessenger.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyPhysicsListMessenger.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyPhysicsListMessenger.cc	(revision 1230)
@@ -24,54 +24,100 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyPhisicsListMessenger.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// HadrontherapyPhysicsListMessenger.cc
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+
 #include "HadrontherapyPhysicsListMessenger.hh"
+
 #include "HadrontherapyPhysicsList.hh"
 #include "G4UIdirectory.hh"
-#include "G4UIcmdWithoutParameter.hh"
-#include "G4UIcmdWithADouble.hh"
 #include "G4UIcmdWithADoubleAndUnit.hh"
-#include "G4UIcmdWithABool.hh"
 #include "G4UIcmdWithAString.hh"
 
-HadrontherapyPhysicsListMessenger::HadrontherapyPhysicsListMessenger(HadrontherapyPhysicsList * physList)
-:physicsList(physList)
-{  
- listDir = new G4UIdirectory("/physics/");
-  // Building modular PhysicsList
+/////////////////////////////////////////////////////////////////////////////
+HadrontherapyPhysicsListMessenger::HadrontherapyPhysicsListMessenger(HadrontherapyPhysicsList* pPhys)
+:pPhysicsList(pPhys)
+{
+  physDir = new G4UIdirectory("/physic/");
+  physDir->SetGuidance("Commands to activate physics models and set cuts");
+   
+  gammaCutCmd = new G4UIcmdWithADoubleAndUnit("/physic/setGCut",this);  
+  gammaCutCmd->SetGuidance("Set gamma cut.");
+  gammaCutCmd->SetParameterName("Gcut",false);
+  gammaCutCmd->SetUnitCategory("Length");
+  gammaCutCmd->SetRange("Gcut>0.0");
+  gammaCutCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
 
- physicsListCmd = new G4UIcmdWithAString("/physics/addPhysics",this);  
- physicsListCmd->SetGuidance("Add chunks of PhysicsList.");
- physicsListCmd->SetParameterName("physList",false);
- physicsListCmd->AvailableForStates(G4State_PreInit);
+  electCutCmd = new G4UIcmdWithADoubleAndUnit("/physic/setECut",this);  
+  electCutCmd->SetGuidance("Set electron cut.");
+  electCutCmd->SetParameterName("Ecut",false);
+  electCutCmd->SetUnitCategory("Length");
+  electCutCmd->SetRange("Ecut>0.0");
+  electCutCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
+  
+  protoCutCmd = new G4UIcmdWithADoubleAndUnit("/physic/setPCut",this);  
+  protoCutCmd->SetGuidance("Set positron cut.");
+  protoCutCmd->SetParameterName("Pcut",false);
+  protoCutCmd->SetUnitCategory("Length");
+  protoCutCmd->SetRange("Pcut>0.0");
+  protoCutCmd->AvailableForStates(G4State_PreInit,G4State_Idle);  
+
+  allCutCmd = new G4UIcmdWithADoubleAndUnit("/physic/setCuts",this);  
+  allCutCmd->SetGuidance("Set cut for all.");
+  allCutCmd->SetParameterName("cut",false);
+  allCutCmd->SetUnitCategory("Length");
+  allCutCmd->SetRange("cut>0.0");
+  allCutCmd->AvailableForStates(G4State_PreInit,G4State_Idle);  
+
+  pListCmd = new G4UIcmdWithAString("/physic/addPhysics",this);  
+  pListCmd->SetGuidance("Add physics list.");
+  pListCmd->SetParameterName("PList",false);
+  pListCmd->AvailableForStates(G4State_PreInit);  
+
+  packageListCmd = new G4UIcmdWithAString("/physic/addPackage",this);
+  packageListCmd->SetGuidance("Add physics package.");
+  packageListCmd->SetParameterName("package",false);
+  packageListCmd->AvailableForStates(G4State_PreInit);
 }
 
+/////////////////////////////////////////////////////////////////////////////
 HadrontherapyPhysicsListMessenger::~HadrontherapyPhysicsListMessenger()
 {
-  delete physicsListCmd;
-  delete listDir;
+  delete gammaCutCmd;
+  delete electCutCmd;
+  delete protoCutCmd;
+  delete allCutCmd;
+  delete pListCmd;
+  delete physDir;    
+  delete packageListCmd;
 }
 
-void HadrontherapyPhysicsListMessenger::SetNewValue(G4UIcommand* command,G4String newValue)
-{
- if (command == physicsListCmd)
-    { physicsList->AddPhysicsList(newValue);} 
-}
+/////////////////////////////////////////////////////////////////////////////
+void HadrontherapyPhysicsListMessenger::SetNewValue(G4UIcommand* command,
+                                          G4String newValue)
+{       
+  if( command == gammaCutCmd )
+   { pPhysicsList->SetCutForGamma(gammaCutCmd->GetNewDoubleValue(newValue));}
+     
+  if( command == electCutCmd )
+   { pPhysicsList->SetCutForElectron(electCutCmd->GetNewDoubleValue(newValue));}
+     
+  if( command == protoCutCmd )
+   { pPhysicsList->SetCutForPositron(protoCutCmd->GetNewDoubleValue(newValue));}
+
+  if( command == allCutCmd )
+    {
+      G4double cut = allCutCmd->GetNewDoubleValue(newValue);
+      pPhysicsList->SetCutForGamma(cut);
+      pPhysicsList->SetCutForElectron(cut);
+      pPhysicsList->SetCutForPositron(cut);
+    } 
+
+  if( command == pListCmd )
+   { pPhysicsList->AddPhysicsList(newValue);}
 
 
+  if( command == packageListCmd )
+   { pPhysicsList->AddPackage(newValue);}
 
 
-
-
+}
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorAction.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorAction.cc	(revision 1230)
@@ -24,5 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyPositronPrimaryGeneratorAction.cc; May 2005
+// HadrontherapyPrimarygeneratorAction.cc;
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
 // ----------------------------------------------------------------------------
 //                 GEANT 4 - Hadrontherapy example
@@ -30,12 +31,13 @@
 // Code developed by:
 //
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
+// G.A.P. Cirrone(a)*, F.Romano(a)
 // 
 // (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
+//     of the INFN, Catania, Italy
 // 
 // * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+//
+// ------------------------------------------------------------------------------
+
 #include "HadrontherapyPrimaryGeneratorAction.hh"
 #include "HadrontherapyPrimaryGeneratorMessenger.hh"
@@ -45,4 +47,5 @@
 #include "G4ParticleDefinition.hh"
 #include "Randomize.hh"
+#include "HadrontherapyAnalysisManager.hh"
 
 HadrontherapyPrimaryGeneratorAction::HadrontherapyPrimaryGeneratorAction()
@@ -75,15 +78,21 @@
 
   // Define the energy of primary particles:
-  // gaussian distribution with mean energy = 64.55 *MeV
-  // and sigma = 300.0 *keV
-  G4double defaultMeanKineticEnergy = 63.50 *MeV;
+  // gaussian distribution with mean energy = 62.0 *MeV
+  // and sigma = 400.0 *keV
+  G4double defaultMeanKineticEnergy = 62.0 *MeV;
   meanKineticEnergy = defaultMeanKineticEnergy;
 
-  G4double defaultsigmaEnergy = 300.0 *keV;
+  G4double defaultsigmaEnergy = 400.0 *keV;
   sigmaEnergy = defaultsigmaEnergy;
+  
+#ifdef ANALYSIS_USE
+  // Write these values into the analysis if needed. Have to be written separately on change.
+  HadrontherapyAnalysisManager::getInstance()->setBeamMetaData(meanKineticEnergy, sigmaEnergy);
+#endif
 
   // Define the parameters of the initial position: 
   // the y, z coordinates have a gaussian distribution
-  G4double defaultX0 = -3248.59 *mm;  
+  
+  G4double defaultX0 = -2700.0 *mm;
   X0 = defaultX0;
 
@@ -111,4 +120,9 @@
 void HadrontherapyPrimaryGeneratorAction::GeneratePrimaries(G4Event* anEvent)
 {
+#ifdef ANALYSIS_USE
+  // Increment the event counter
+  HadrontherapyAnalysisManager::getInstance()->startNewEvent();
+#endif
+
   // ****************************************
   // Set the beam angular apread 
@@ -162,8 +176,21 @@
 
 void HadrontherapyPrimaryGeneratorAction::SetmeanKineticEnergy (G4double val )  
-{ meanKineticEnergy = val;} 
+{
+	meanKineticEnergy = val;
+#ifdef ANALYSIS_USE
+  // Update the beam-data in the analysis manager
+  HadrontherapyAnalysisManager::getInstance()->setBeamMetaData(meanKineticEnergy, sigmaEnergy);
+#endif
+
+} 
 
 void HadrontherapyPrimaryGeneratorAction::SetsigmaEnergy (G4double val )  
-{ sigmaEnergy = val;}
+{ 
+	sigmaEnergy = val;
+#ifdef ANALYSIS_USE
+  // Update the sigmaenergy in the metadata.
+  HadrontherapyAnalysisManager::getInstance()->setBeamMetaData(meanKineticEnergy, sigmaEnergy);
+#endif
+}
 
 void HadrontherapyPrimaryGeneratorAction::SetXposition (G4double val )  
@@ -187,2 +214,5 @@
 void HadrontherapyPrimaryGeneratorAction::SetsigmaMomentumZ (G4double val )  
 { sigmaMomentumZ = val;}
+
+G4double HadrontherapyPrimaryGeneratorAction::GetmeanKineticEnergy(void)
+{ return meanKineticEnergy;}
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorMessenger.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorMessenger.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyPrimaryGeneratorMessenger.cc	(revision 1230)
@@ -24,18 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyPrimaryGeneratorMessenger.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// HadrontherapyPrimaryGeneratorMessenger.cc;
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
 
 #include "HadrontherapyPrimaryGeneratorMessenger.hh"
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyRunAction.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyRunAction.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyRunAction.cc	(revision 1230)
@@ -24,18 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyRunAction.cc,v 3.0, September 2004;
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the INFN, Catania, Italy
-// (b) INFN Section of Genova, Genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// $Id: HadrontherapyRunAction.cc
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
 
 #include "HadrontherapyRunAction.hh"
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapySteppingAction.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapySteppingAction.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapySteppingAction.cc	(revision 1230)
@@ -24,18 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyProtonSteppingAction.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the INFN, Catania, Italy
-// (b) INFN Section of Genova, Genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// HadrontherapyProtonSteppingAction.cc; 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
 
 #include "G4SteppingManager.hh"
@@ -52,24 +40,74 @@
 #include "G4ParticleTypes.hh"
 
-#ifdef G4ANALYSIS_USE 	
 #include "HadrontherapyAnalysisManager.hh"
-#endif
 
 #include "HadrontherapyRunAction.hh"
 
-HadrontherapySteppingAction::HadrontherapySteppingAction( HadrontherapyRunAction* run)
+/////////////////////////////////////////////////////////////////////////////
+HadrontherapySteppingAction::HadrontherapySteppingAction( HadrontherapyRunAction *run)
 {
   runAction = run;
 }
 
+/////////////////////////////////////////////////////////////////////////////
 HadrontherapySteppingAction::~HadrontherapySteppingAction()
 {
 }
 
+/////////////////////////////////////////////////////////////////////////////
 void HadrontherapySteppingAction::UserSteppingAction(const G4Step* aStep)
 { 
+    if( aStep->GetTrack()->GetVolume()->GetName() == "NewDetectorPhys"){
+#ifdef ANALYSIS_USE
+      G4ParticleDefinition *def = aStep->GetTrack()->GetDefinition();
+      G4double secondaryParticleKineticEnergy =  aStep->GetTrack()->GetKineticEnergy();     
+      G4String particleType = def->GetParticleType(); // particle type = nucleus for d, t, He3, alpha, and heavier nuclei
+      G4String particleName = def->GetParticleName(); // e.g. for alpha: the name = "alpha" and type = "nucleus"
+      if(particleType == "nucleus") {
+	G4int A = def->GetBaryonNumber();
+	G4double Z = def->GetPDGCharge();
+	G4double posX = aStep->GetTrack()->GetPosition().x() / cm;
+	G4double posY = aStep->GetTrack()->GetPosition().y() / cm;
+	G4double posZ = aStep->GetTrack()->GetPosition().z() / cm;
+	G4double energy = secondaryParticleKineticEnergy / A / MeV;
+
+	HadrontherapyAnalysisManager* analysisMgr =  HadrontherapyAnalysisManager::getInstance();   
+	analysisMgr->fillFragmentTuple(A, Z, energy, posX, posY, posZ);
+      } else if(particleName == "proton") {   // proton (hydrogen-1) is a special case
+	G4double posX = aStep->GetTrack()->GetPosition().x() / cm ;
+	G4double posY = aStep->GetTrack()->GetPosition().y() / cm ;
+	G4double posZ = aStep->GetTrack()->GetPosition().z() / cm ;
+	G4double energy = secondaryParticleKineticEnergy * MeV;    // Hydrogen-1: A = 1, Z = 1
+	HadrontherapyAnalysisManager::getInstance()->fillFragmentTuple(1, 1.0, energy, posX, posY, posZ);
+      }
+
+      G4String secondaryParticleName =  def -> GetParticleName();  
+      //G4cout <<"Particle: " << secondaryParticleName << G4endl;
+      //G4cout <<"Energy: " << secondaryParticleKineticEnergy << G4endl;
+	HadrontherapyAnalysisManager* analysis =  HadrontherapyAnalysisManager::getInstance();   
+	//There is a bunch of stuff recorded with the energy 0, something should perhaps be done about this.
+	if(secondaryParticleName == "proton") {
+	  analysis->hydrogenEnergy(secondaryParticleKineticEnergy / MeV);
+	}
+	if(secondaryParticleName == "deuteron") {
+	  analysis->hydrogenEnergy((secondaryParticleKineticEnergy/2) / MeV);
+	}
+	if(secondaryParticleName == "triton") {
+	  analysis->hydrogenEnergy((secondaryParticleKineticEnergy/3) / MeV);
+	}
+	if(secondaryParticleName == "alpha") {
+	  analysis->heliumEnergy((secondaryParticleKineticEnergy/4) / MeV);
+	}
+	if(secondaryParticleName == "He3"){
+	  analysis->heliumEnergy((secondaryParticleKineticEnergy/3) / MeV);		
+	}
+#endif
+
+	aStep->GetTrack()->SetTrackStatus(fKillTrackAndSecondaries);
+    }
+
   // Electromagnetic and hadronic processes of primary particles in the phantom
-  
- if ((aStep -> GetTrack() -> GetTrackID() == 1) &&
+  //setting phantomPhys correctly will break something here fixme
+  if ((aStep -> GetTrack() -> GetTrackID() == 1) &&
     (aStep -> GetTrack() -> GetVolume() -> GetName() == "PhantomPhys") &&
     (aStep -> GetPostStepPoint() -> GetProcessDefinedStep() != NULL))
@@ -96,10 +134,8 @@
  // Retrieve information about the secondaries originated in the phantom
 
-#ifdef G4ANALYSIS_USE 	
-  G4SteppingManager*  steppingManager = fpSteppingManager;
-  G4Track* theTrack = aStep -> GetTrack();
-
+ G4SteppingManager*  steppingManager = fpSteppingManager;
+  
   // check if it is alive
-  if(theTrack-> GetTrackStatus() == fAlive) { return; }
+  //if(theTrack-> GetTrackStatus() == fAlive) { return; }
 
   // Retrieve the secondary particles
@@ -110,9 +146,10 @@
       G4String volumeName = (*fSecondary)[lp1] -> GetVolume() -> GetName(); 
  
-      if (volumeName == "PhantomPhys")
+      if (volumeName == "phantomPhys")
 	{
+#ifdef ANALYSIS_USE   
 	  G4String secondaryParticleName =  (*fSecondary)[lp1]->GetDefinition() -> GetParticleName();  
 	  G4double secondaryParticleKineticEnergy =  (*fSecondary)[lp1] -> GetKineticEnergy();     
-   
+
 	  HadrontherapyAnalysisManager* analysis =  HadrontherapyAnalysisManager::getInstance();   
         
@@ -137,11 +174,12 @@
 	      G4int a = (*fSecondary)[lp1]-> GetDynamicParticle() -> GetDefinition() -> GetBaryonNumber();
 	      G4int electronOccupancy = (*fSecondary)[lp1] ->  GetDynamicParticle() -> GetTotalOccupancy(); 
-	      // If a generic ion is originated in the phantom, its baryonic number, PDG charge, 
+	      
+	      // If a generic ion is originated in the detector, its baryonic number, PDG charge, 
 	      // total number of electrons in the orbitals are stored in a ntuple 
-	      analysis -> genericIonInformation(a, z, electronOccupancy, secondaryParticleKineticEnergy/MeV);			
+	      analysis -> genericIonInformation(a, z, electronOccupancy, secondaryParticleKineticEnergy/MeV);
 	    }
+#endif
 	}
     }
-#endif
 }
 
